# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from calibration_msgs/DenseLaserObjectFeatures.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import calibration_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class DenseLaserObjectFeatures(genpy.Message):
  _md5sum = "b642d46e47d54e00f98a3d98b02b5cc6"
  _type = "calibration_msgs/DenseLaserObjectFeatures"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Synchronized with sensor output
Header header

# Pixel locations of detected features
DenseLaserPoint[] dense_laser_points

# Defines geometry of detected features in some "object" coordinate frame
geometry_msgs/Point[] object_points

# False on detection failure or partial detection
uint8 success

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: calibration_msgs/DenseLaserPoint
# Stores the xy subpixel location of a point in a DenseLaserSnapshot
float64 scan  # Which scan line we detected the feature
float64 ray   # Which ray in the specified scan we detected the feature

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['header','dense_laser_points','object_points','success']
  _slot_types = ['std_msgs/Header','calibration_msgs/DenseLaserPoint[]','geometry_msgs/Point[]','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,dense_laser_points,object_points,success

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DenseLaserObjectFeatures, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.dense_laser_points is None:
        self.dense_laser_points = []
      if self.object_points is None:
        self.object_points = []
      if self.success is None:
        self.success = 0
    else:
      self.header = std_msgs.msg.Header()
      self.dense_laser_points = []
      self.object_points = []
      self.success = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.dense_laser_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.dense_laser_points:
        _x = val1
        buff.write(_struct_2d.pack(_x.scan, _x.ray))
      length = len(self.object_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_points:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      buff.write(_struct_B.pack(self.success))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.dense_laser_points is None:
        self.dense_laser_points = None
      if self.object_points is None:
        self.object_points = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.dense_laser_points = []
      for i in range(0, length):
        val1 = calibration_msgs.msg.DenseLaserPoint()
        _x = val1
        start = end
        end += 16
        (_x.scan, _x.ray,) = _struct_2d.unpack(str[start:end])
        self.dense_laser_points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.object_points.append(val1)
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.dense_laser_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.dense_laser_points:
        _x = val1
        buff.write(_struct_2d.pack(_x.scan, _x.ray))
      length = len(self.object_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_points:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      buff.write(_struct_B.pack(self.success))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.dense_laser_points is None:
        self.dense_laser_points = None
      if self.object_points is None:
        self.object_points = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.dense_laser_points = []
      for i in range(0, length):
        val1 = calibration_msgs.msg.DenseLaserPoint()
        _x = val1
        start = end
        end += 16
        (_x.scan, _x.ray,) = _struct_2d.unpack(str[start:end])
        self.dense_laser_points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.object_points.append(val1)
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d = struct.Struct("<2d")
_struct_3I = struct.Struct("<3I")
_struct_B = struct.Struct("<B")
_struct_3d = struct.Struct("<3d")
